package com.jiuqi.grid;

import java.io.Serializable;
import java.util.ArrayList;
import java.util.List;

public class Matrix implements Serializable {
   private int xCount;
   private int yCount;
   private List list = new ArrayList();

   public int getXCount() {
      return this.xCount;
   }

   public int getYCount() {
      return this.yCount;
   }

   public void setSize(int xSize, int ySize) {
      if (xSize >= 0 && ySize >= 0) {
         int c = false;
         int i;
         int c;
         if (this.xCount != xSize) {
            for(i = this.xCount; i < xSize; ++i) {
               this.list.add(new ArrayList());
            }

            c = this.list.size();

            for(i = c; i > xSize; --i) {
               this.list.remove(i - 1);
            }

            this.xCount = xSize;
         }

         List data;
         int j;
         if (this.yCount < ySize) {
            for(i = 0; i < this.xCount; ++i) {
               data = (List)this.list.get(i);
               if (data != null) {
                  for(j = this.yCount; j < ySize; ++j) {
                     data.add((Object)null);
                  }
               }
            }

            this.yCount = ySize;
         }

         if (this.yCount > ySize) {
            for(i = 0; i < this.xCount; ++i) {
               data = (List)this.list.get(i);
               if (data != null) {
                  c = data.size();

                  for(j = c; j > ySize; --j) {
                     data.remove(j - 1);
                  }
               }
            }

            this.yCount = ySize;
         }

      }
   }

   public void resetSize(int xSize, int ySize) {
      this.setSize(xSize, ySize);

      for(int x = 0; x < this.getXCount(); ++x) {
         for(int y = 0; y < this.getYCount(); ++y) {
            this.setElement(x, y, (Object)null);
         }
      }

   }

   public Object getElement(int x, int y) {
      if (x >= 0 && y >= 0 && x < this.xCount && y < this.yCount) {
         List data = (List)this.list.get(x);
         return data != null && y < data.size() ? data.get(y) : null;
      } else {
         return null;
      }
   }

   public void setElement(int x, int y, Object obj) {
      if (x >= 0 && y >= 0 && x < this.xCount && y < this.yCount) {
         List data = (List)this.list.get(x);
         if (data == null && obj != null) {
            data = new ArrayList();
            this.list.set(x, data);
         }

         if (data != null) {
            for(int i = ((List)data).size(); i < this.yCount; ++i) {
               ((List)data).add((Object)null);
            }

            ((List)data).set(y, obj);
         }
      }

   }

   public boolean hasElement(Object o) {
      for(int i = 0; i < this.list.size(); ++i) {
         List data = (List)this.list.get(i);
         if (data != null && data.indexOf(o) >= 0) {
            return true;
         }
      }

      return false;
   }

   public void xDelete(int x) {
      this.list.remove(x);
      --this.xCount;
   }

   public void xDelete(int x, int count) {
      for(int i = 0; i < count; ++i) {
         this.xDelete(x);
      }

   }

   public void yDelete(int y) {
      for(int i = 0; i < this.list.size(); ++i) {
         List data = (List)this.list.get(i);
         if (data != null && y < data.size()) {
            data.remove(y);
         }
      }

      --this.yCount;
   }

   public void yDelete(int y, int count) {
      for(int i = 0; i < count; ++i) {
         this.yDelete(y);
      }

   }

   public void xInsert(int x, int count) {
      for(int i = 0; i < count; ++i) {
         this.list.add(x, (Object)null);
      }

      this.xCount += count;
   }

   public void yInsert(int y, int count) {
      if (y >= 0 && y <= this.yCount) {
         for(int i = 0; i < this.list.size(); ++i) {
            List data = (List)this.list.get(i);
            if (data != null && y <= data.size()) {
               for(int k = 0; k < count; ++k) {
                  data.add(y, (Object)null);
               }
            }
         }

         this.yCount += count;
      }
   }

   public void xExchange(int x1, int x2) {
      if (x1 >= 0 && x2 >= 0 && x1 < this.xCount && x2 < this.xCount) {
         Object data = this.list.get(x1);
         this.list.set(x1, this.list.get(x2));
         this.list.set(x2, data);
      }
   }

   public void yExchange(int y1, int y2) {
      if (y1 >= 0 && y2 >= 0 && y1 < this.yCount && y2 < this.yCount && y1 != y2) {
         for(int i = 0; i < this.list.size(); ++i) {
            List data = (List)this.list.get(i);
            if (data != null && (y1 < data.size() || y2 < data.size())) {
               for(int k = data.size(); k < this.yCount; ++k) {
                  data.add((Object)null);
               }

               Object o = data.get(y1);
               data.set(y1, data.get(y2));
               data.set(y2, o);
            }
         }

      }
   }

   public void xCopy(int fromIndex, int toIndex) {
      List data = (List)this.list.get(fromIndex);
      if (data == null) {
         this.list.set(toIndex, (Object)null);
      } else {
         List newData = new ArrayList();
         newData.addAll(data);
         this.list.set(toIndex, newData);
      }

   }

   public void yCopy(int fromIndex, int toIndex) {
      for(int i = 0; i < this.list.size(); ++i) {
         List data = (List)this.list.get(i);
         if (data != null && (fromIndex < data.size() || toIndex < data.size())) {
            for(int k = data.size(); k < this.yCount; ++k) {
               data.add((Object)null);
            }

            data.set(toIndex, data.get(fromIndex));
         }
      }

   }
}
